
//function componentBarChart(name, target){
function componentBarChart(name, target, data){

    //var data = [4, 8, 15, 16, 23, 42];
    var w = 480, //width
    h = 20, //height
    color = d3.scale.category20c(); //builtin range of colors

 var chart = d3.select(target).append("svg")
      .attr("class", "barchart")
      .attr("width", w)
      .attr("height", h * data.length);

var x = d3.scale.linear()
      .domain([0, d3.max(data, function(d) {return d.value})+10])
      .range([0, 420]);

//var y = d3.scale.ordinal()
//     .domain(data)
//     .rangeBands([0, 50]);


// .attr("y", function(d, i) { return i * 20; })

chart.selectAll("rect")
     .data(data)
     .enter().append("rect")
     .attr("y", function(d, i) { return i * 20; })
     //.attr("y", function(d) { return y(d) + y.rangeBand() / 2; })
     .attr("width", function(d, i) {return x(d.value);})
     .attr("height", 20);

chart.selectAll("text")
     .data(data)
     .enter().append("text")
     .text(function(d) {
         return d.label;
     })
     .attr("x", function(d, i) {return x(d.value);})
     //.attr("y", function(d) { return y(d) + y.rangeBand() / 2; })
     .attr("y", function(d, i) { return i * 20 + 10; })
     .attr("dx", 3) // padding-right
     //.attr("dy", ".5em") // vertical-align: middle
     .attr("text-anchor", "right") // text-align: right
     .attr("fill", "black")
     .attr("font-family", "sans-serif")
     .attr("font-size", "9px");

//chart.selectAll("line")
//      .data(x.ticks(10))
//    .enter().append("line")
//      .attr("x1", x)
//      .attr("x2", x)
//      .attr("y1", 0)
//      .attr("y2", h * data.length)
//      .style("stroke", "#ccc");
//
//chart.selectAll(".rule")
//      .data(x.ticks(10))
//    .enter().append("text")
//      .attr("class", "rule")
//      .attr("x", x)
//      .attr("y", 0)
//      .attr("dy", -3)
//      .attr("text-anchor", "middle")
//      .text(String);
//
// chart.append("line")
//      .attr("y1", 0)
//      .attr("y2", h * data.length)
//      .style("stroke", "#000");
}

function bugPieChart(name, target, data){
    var w = 200, //width
    h = 300, //height
    r = 100, //radius
    color = d3.scale.category20c(); //builtin range of colors

    var vis = d3.select(target)
        .append("svg:svg") //create the SVG element inside the <body>
        .data([data]) //associate our data with the document
            .attr("width", w) //set the width and height of our visualization (these will be attributes of the <svg> tag
            .attr("height", h)
        .append("svg:g") //make a group to hold our pie chart
            .attr("transform", "translate(" + r + "," + r + ")") //move the center of the pie chart from 0, 0 to radius, radius

    var arc = d3.svg.arc() //this will create <path> elements for us using arc data
        .outerRadius(r);

    var pie = d3.layout.pie() //this will create arc data for us given a list of values
        .value(function(d) { return d.value; }); //we must tell it out to access the value of each element in our data array

    var arcs = vis.selectAll("g.slice") //this selects all <g> elements with class slice (there aren't any yet)
        .data(pie) //associate the generated pie data (an array of arcs, each having startAngle, endAngle and value properties)
        .enter() //this will create <g> elements for every "extra" data element that should be associated with a selection. The result is creating a <g> for every object in the data array
            .append("svg:g") //create a group to hold each slice (we will have a <path> and a <text> element associated with each slice)
                .attr("class", "slice"); //allow us to style things in the slices (like text)

        arcs.append("svg:path")
                .attr("fill", function(d, i) { return color(i); } ) //set the color for each slice to be chosen from the color function defined above
                .attr("d", arc); //this creates the actual SVG path using the associated data (pie) with the arc drawing function

        arcs.append("svg:text") //add a label to each slice
                .attr("transform", function(d) { //set the label's origin to the center of the arc
                //we have to make sure to set these before calling arc.centroid
                d.innerRadius = 0;
                d.outerRadius = r;
                return "translate(" + arc.centroid(d) + ")"; //this gives us a pair of coordinates like [50, 50]
            })
            .attr("text-anchor", "middle") //center the text on it's origin
            .text(function(d, i) { return data[i].label + " (" + data[i].value + ")"; }); //get the label from our original data array
            }

